unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls
  , SQLite3Conn
  //, SQLDBLib
  , SQLDB
  //if you want to use other database connections than SQLite you need the corresponding includes
  , pqconnection, ibconnection, mssqlconn, oracleconnection
  ,odbcconn
  ,mysql40conn
  ,mysql41conn
  ,mysql50conn
  ,mysql51conn
  ,mysql55conn
  ,mysql56conn
  ,mysql57conn
  ,mysql80conn
  ;

const
  cUNDEF ='undefined';

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    function GetStandardLibraryName(sConnector:string):string;
    function ListLibs:string;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  memo1.Append(ListLibs);
end;

function TForm1.GetStandardLibraryName(sConnector: string): string;
var
  S : TStringList;
  I : Integer;
begin
  result:=cUNDEF;
  S:=TStringList.Create;
  try
    getConnectionList(S);
    For I:=0 to S.Count-1 do
      if S[i] = sConnector then begin
        result := GetConnectionDef(S[i]).DefaultLibraryName;
        exit;
      end;
  finally
    S.free;
  end;

end;

function TForm1.ListLibs: string;
Var
  S : TStringList;
  I : Integer;

begin
  S:=TStringList.Create;
  try
    getConnectionList(S);
    result:=LineEnding +'Available connection types:';
    For I:=0 to S.Count-1 do
      result:= result + LineEnding + S[i] + ', Default library name: ' + GetConnectionDef(S[i]).DefaultLibraryName;
  finally
    S.free;
  end;

end;

end.

